package com.zcloud.service.onlinexxks;

import com.zcloud.entity.Page;
import com.zcloud.entity.PageData;

import java.util.List;

/**
 * 说明：课程学员关系表
 * 作者：luoxiaobao
 * 时间：2021-09-10
 * 官网：www.zcloudchina.com
 */
public interface CourseStudentRelationService{

	/**新增
	 * @param pd
	 * @throws Exception
	 */
	public void save(PageData pd)throws Exception;

	/**删除
	 * @param pd
	 * @throws Exception
	 */
	public void delete(PageData pd)throws Exception;

	/**修改
	 * @param pd
	 * @throws Exception
	 */
	public void edit(PageData pd)throws Exception;

	/**列表
	 * @param page
	 * @throws Exception
	 */
	public List<PageData> list(Page page)throws Exception;

	/**列表(全部)
	 * @param pd
	 * @throws Exception
	 */
	public List<PageData> listAll(PageData pd)throws Exception;

	/**通过id获取数据
	 * @param pd
	 * @throws Exception
	 */
	public PageData findById(PageData pd)throws Exception;

	/**批量删除
	 * @param pd
	 * @throws Exception
	 */
	public void deleteAll(PageData pd)throws Exception;

	/**列表(根据所选ID获取数据)
	 * @param pd
	 * @throws Exception
	 */
	List<PageData> findByIds(PageData pd)throws Exception;

	/**新增(保存课程主表后保存符合人员类别的人员)
	 * @param pd
	 * @throws Exception
	 */
	void saveByCurriculum(PageData pd) throws Exception;

	/**批量删除（根据所选的课程进行删除课程学员关系表）
	 * @param pd
	 * @throws Exception
	 */
	public void deleteByCurriculumIds(PageData pd)throws Exception;

	/**修改（更新学员状态）
	 * @param
	 * @throws Exception
	 */
	public void updateStudentState(PageData pd)throws Exception;

	/**修改（更新学员考试成绩及状态）
	 * @param
	 * @throws Exception
	 */
	public void updateStudentScore(PageData pd)throws Exception;

	/**
	 * 课程结束（定时任务，处理没有参加考试的学员课程，课程结束STUDYSTATE = '4'，考试未考COURSEEXAMSTATE = '4'）
	 * @param pd
	 * @throws Exception
	 */
    void overCourseNotInvolved(PageData pd)throws Exception;

	/**
	 * 课程结束（定时任务，处理参加考试的学员课程，课程结束STUDYSTATE = '4'）
	 * @param pd
	 * @throws Exception
	 */
	void overCourse(PageData pd)throws Exception;
}

